#include <Windows.h>
#include "CondMgre.h"
#include <stdio.h>
#include <condmgre.h>
const char *kCreator = "BOXR";
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int cmdShow)
{
  int err;
  err =
    MessageBox(0,
               "Do you want UnBoxer Installed?\nYes (re)installs, No uninstalls.",
               "UnBoxer Conduit Installation",
               MB_YESNOCANCEL | MB_ICONASTERISK); if (err == IDYES) {
    if (err = CmInstallCreator(kCreator, CONDUIT_APPLICATION))
      return err;
    if (err = CmSetCreatorName(kCreator, "BoxrCn20.DLL"))
      return err;
    if (err = CmSetCreatorDirectory(kCreator, "Unboxed"))
      return err;
    if (err = CmSetCreatorFile(kCreator, "default"))
      return err;
    if (err = CmSetCreatorPriority(kCreator, 2))
      return err;
  }

  else if (err == IDNO)
    return CmRemoveConduitByCreatorID(kCreator);
  return 0;
}
